"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isJSXAttributeKey = exports.isFragment = void 0;
function isFragment(node, reactPragma, fragmentPragma) {
    const name = node.openingElement.name;
    // <Fragment>
    if (name.type === "JSXIdentifier" && name.name === fragmentPragma) {
        return true;
    }
    // <React.Fragment>
    if (name.type === "JSXMemberExpression" &&
        name.object.type === "JSXIdentifier" &&
        name.object.name === reactPragma &&
        name.property.type === "JSXIdentifier" &&
        name.property.name === fragmentPragma) {
        return true;
    }
    return false;
}
exports.isFragment = isFragment;
/**
 * Check if node is like `key={...}` as in `<Foo key={...} />`
 */
function isJSXAttributeKey(node) {
    return (node.type === "JSXAttribute" &&
        node.name &&
        node.name.type === "JSXIdentifier" &&
        node.name.name === "key");
}
exports.isJSXAttributeKey = isJSXAttributeKey;
//# sourceMappingURL=jsx.js.map