"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getFromContext = exports.getFragmentFromContext = void 0;
const t = __importStar(require("io-ts"));
const Either_1 = require("fp-ts/lib/Either");
const ReactSettings = t.type({
    react: t.type({
        fragment: t.union([t.string, t.undefined]),
        pragma: t.union([t.string, t.undefined]),
    }),
});
const JSX_ANNOTATION_REGEX = /@jsx\s+([^\s]+)/;
// Does not check for reserved keywords or unicode characters
const JS_IDENTIFIER_REGEX = /^[_$a-zA-Z][_$a-zA-Z0-9]*$/;
function getFragmentFromContext(context) {
    let pragma = "Fragment";
    const settings = ReactSettings.decode(context.settings);
    // .eslintrc shared settings (http://eslint.org/docs/user-guide/configuring#adding-shared-settings)
    if (Either_1.isRight(settings) &&
        settings.right.react &&
        settings.right.react.fragment) {
        pragma = settings.right.react.fragment;
    }
    if (!JS_IDENTIFIER_REGEX.test(pragma)) {
        throw new Error(`Fragment pragma ${pragma} is not a valid identifier`);
    }
    return pragma;
}
exports.getFragmentFromContext = getFragmentFromContext;
function getFromContext(context) {
    let pragma = "React";
    const sourceCode = context.getSourceCode();
    const pragmaNode = sourceCode
        .getAllComments()
        .find((node) => JSX_ANNOTATION_REGEX.test(node.value));
    if (pragmaNode) {
        const matches = JSX_ANNOTATION_REGEX.exec(pragmaNode.value);
        pragma = matches === null || matches === void 0 ? void 0 : matches[1].split(".")[0];
        // .eslintrc shared settings (http://eslint.org/docs/user-guide/configuring#adding-shared-settings)
    }
    else {
        const settings = ReactSettings.decode(context.settings);
        if (Either_1.isRight(settings) && settings.right.react.pragma) {
            pragma = settings.right.react.pragma;
        }
    }
    if (pragma == null || !JS_IDENTIFIER_REGEX.test(pragma)) {
        throw new Error(`React pragma ${pragma} is not a valid identifier`);
    }
    return pragma;
}
exports.getFromContext = getFromContext;
//# sourceMappingURL=pragma.js.map